/***********************************************************************/
/*                                                                     */
/*  FILE        :Audio_out.c                                           */
/*  DATE        :Mar. 05, 2011                                         */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :H8SX/1655                                             */
/*                                                                     */
/*  This file is generated by Renesas Project Generator (Ver.4.16).    */
/*                                                                     */
/***********************************************************************/
                  
#include "iodefine.h"
#include <machine.h>

void main(void);
#ifdef __cplusplus
extern "C" {
void abort(void);
}
#endif

#define min_samp_freq 12000
#define samp_freq 12000
#define timer_input_clock 24000000L
#define nPWMtpu (timer_input_clock/256/min_samp_freq+1)
#define nPWMtmr (timer_input_clock/2/256/min_samp_freq+1)

void open_da(void);
void open_tmr(void);
void open_tpu(void);
void set_sampling_tmr(int rate);

void start_tmr(void);
void start_tpu(void);
void start_sampling(void);

void close_da(void);
void close_tmr(void);
void close_tpu(void);
void output_sound(unsigned short, unsigned short);

unsigned char part_tmr0[nPWMtmr], part_tmr1[nPWMtmr];
unsigned short part_tpu0[nPWMtpu], part_tpu1[nPWMtpu];

#include "adxdcd.h"

#define PCMDECSIZE  32              /* number to convert from ADX into PCM */
#define PCMBUFSIZE  (PCMDECSIZE*10) /* size of decoded sound data buffer */

typedef enum {
    PLAY_NONE       = 0,            /* no sound data output */
    PLAY_PLAYBACK,                  /* during sound data output */
    PLAY_END                        /* end of sound data output */
} PLAYMODE;

typedef struct {
    unsigned char const   *input;     /* top address of ADX (input) */
    signed short          *output;    /* top address of PCM (output) */
    unsigned int          size;       /* number to decode */
    signed char           id;         /* unused */
    signed short          vp;         /* unused */
	AdxHeaderInfo         inf;		  /* ADX header information structure */
} T_ADPCM;

typedef struct                            /* decoded information structure */
{
    T_ADPCM        *adpcm;                /* ADX decoding structure */
    short pcm_data[PCMDECSIZE];           /* decoded sound data(16bit) storage */
    PLAYMODE       playmode;              /* state of playback */
    unsigned long  decno;                 /* number of sound data(decoded) */
    unsigned long  playno;                /* number of sound data(completed output) */
} DECINFO;
DECINFO dec_info0;

typedef struct                             /* ring buffer structure */
{
    unsigned short  buff[PCMBUFSIZE];      /* 8bit PCM data storage */
    unsigned short  *w_pos;                /* write address of ring buffer */
    unsigned short  *r_pos;                /* read address of ring buffer */
    unsigned short  empty;                 /* writable size of ring buffer */
} RINGBUFFER;
RINGBUFFER  rbf0;

T_ADPCM st_adpcm0;                        /* ADX decoding structure */

void InitDecInfo( DECINFO *info, T_ADPCM *adpcm, const unsigned char *addr, int decsize );
void InitRingBuffer( RINGBUFFER *rbf );
void DecodeProc( DECINFO *info, RINGBUFFER *rbf );
void RingBufferSetData( DECINFO *info, RINGBUFFER *rbf );
void RingBufferPush( short *src, unsigned short *dest, int times );
unsigned short ConvertSint16toUint16( short data );
void SetPCMdataCH0( void );


//#ifdef E10A 0
#if 0
  /*E10A-USB*/
  #define ADPCM_ADDR1      0x004000     /* top address of ADX sound data storage */
#else
  /*Serialmonitor*/
  #define ADPCM_ADDR1      0xff4000     /* top address of ADX sound data storage */
#endif

#define	ADX_BLK_SIZE			(18)		// ubNTCY
#define	ADX_MAX_HEADER_SIZE		(56)

void adx_init( T_ADPCM *adx_hn );
void adx_decode( T_ADPCM *adx_hn );

void adx_init( T_ADPCM *adx_hn )
{
	AdxHeaderInfo	*inf = &adx_hn->inf;
	Sint8			*ptr=NULL;

	ptr = ADX_AnalyzeHeaderInfo((Sint8 *)adx_hn->input, ADX_MAX_HEADER_SIZE, inf);
	adx_hn->input = (unsigned char const *)ptr;
}

void adx_decode( T_ADPCM *adx_hn )
{
	AdxHeaderInfo	*inf = &adx_hn->inf;
	Sint8			*ptr=NULL;
	
	ptr = ADX_DecodeBlock((Sint8 *)adx_hn->input, adx_hn->output, inf->dly_l, inf->k);
	if (ptr == NULL) {
	}
}

void main( void )
{
	open_da();	// 10rbg\Ŏgp
//	open_tmr();	// TMR2,3gp
				//@TMR2,3̏o͒[qTMO2,3gp邽ߓ[qJ-TG𗘗pE10A-USB͗płȂ				
	open_tpu();	// TPU4,5gp
				//@PWM[h1TIOCA4,TIOCA5[qgp邽LCD_CNg쓮͗płȂ
	set_sampling_tmr(samp_freq);	// TvOp^C}ATPU6ŎA͎g
	set_imask_exr(0);	// 荞ݎt

    while(1){

        /* (18oCg) */
        /* channel 0 */
        InitDecInfo( &dec_info0, &st_adpcm0, (const unsigned char *)ADPCM_ADDR1, PCMDECSIZE );
        InitRingBuffer( &rbf0 );

        /* fR[h(擪ubN)*/
        DecodeProc( &dec_info0, &rbf0 );
        dec_info0.playmode = PLAY_PLAYBACK;


        /* ^C}荞݂̉(^C}͖X^[g) */
		start_sampling();

        /* ADXfR[_ׂ̂ĂfR[h */
        while( dec_info0.decno < st_adpcm0.inf.total_nsmpl ){
            /* fR[hƃfR[h̃Abvf[g */
            DecodeProc( &dec_info0, &rbf0 );
        }

        /* SADXf[^̃fR[hAׂĂ̌ʂo͂܂ő҂ */
        while( dec_info0.playmode != PLAY_END ){}
    }

}

//TvO[gݒ肵^C}̊荞ݏ
// vector 164 Reserved
__interrupt(vect=164) void INT_TGI6A_TPU6(void)
{
	TPU6.TSR.BIT.TGFA = 0;	// 荞ݗvtONAAv~
    /* channel0 */
    if( dec_info0.playno >= st_adpcm0.inf.total_nsmpl ){
        /* Audio output is completed */
        dec_info0.playmode = PLAY_END;
    }else{
        /* PCM data(decoded data) --> PWM output */
        SetPCMdataCH0();
    }
}

void InitDecInfo( DECINFO *info, T_ADPCM *adpcm, const unsigned char *addr, int decsize )
{
    info->adpcm = adpcm;
    info->playmode = PLAY_NONE;
    info->decno = 0;
    info->playno = 0;

    /* initialization and the initial setting of ADX decoding structure */
	info->adpcm->input = addr;
    info->adpcm->output = info->pcm_data;
    info->adpcm->size = decsize;
	adx_init( info->adpcm );	
}

void InitRingBuffer( RINGBUFFER *rbf )
{
    rbf->w_pos = &rbf->buff[0];
    rbf->r_pos = &rbf->buff[0];
    rbf->empty = PCMBUFSIZE - PCMDECSIZE;
}

void DecodeProc( DECINFO *info, RINGBUFFER *rbf )
{
   if( rbf->empty >= PCMDECSIZE ){
        adx_decode( info->adpcm );	
        info->adpcm->input += ADX_BLK_SIZE;	
    	
        RingBufferSetData( info, rbf );
    }
}

void RingBufferSetData( DECINFO *info, RINGBUFFER *rbf )
{
    unsigned char push = 0;

    if( rbf->r_pos < rbf->w_pos ){
        if( rbf->w_pos <= &rbf->buff[PCMBUFSIZE - PCMDECSIZE] ){
            /* space available between write position and end of buffer */
            push = 1;
        }else if( rbf->r_pos > &rbf->buff[PCMDECSIZE] ){
            /* write position is at end of buffer, space available at top */
            rbf->w_pos = &rbf->buff[0];
            push = 1;
        }
    }else if( rbf->r_pos > rbf->w_pos ){
        if( rbf->w_pos < (rbf->r_pos - PCMDECSIZE) ){
            /* space available between write position and read position */
            push = 1;
        }
    }else{
        /* not available write data (read position ==  write position) */
        if( info->playmode == PLAY_NONE ){
            /* initial only */
            push = 1;
        }
    }
    
    if( push ){
        RingBufferPush( info->pcm_data, rbf->w_pos, PCMDECSIZE );
        rbf->w_pos += PCMDECSIZE;
        rbf->empty -= PCMDECSIZE;
        info->decno += PCMDECSIZE;
    }
}

void RingBufferPush( short *src, unsigned short *dest, int times )
{
    int i;

    for( i = 0 ; i < times ; i++ ){
        dest[i] = ConvertSint16toUint16( src[i] );
    }
}

unsigned short ConvertSint16toUint16( short data )
{
    return (unsigned short)( data + 0x8000 );
}

unsigned int readErrCntCH0;	// debug
void SetPCMdataCH0( void )
{
    unsigned char pop = 0;                 /* 0 : no PWM output */

    /* send sound data(PCM) to PWM output every sampling period */
    if( rbf0.r_pos < rbf0.w_pos ){
        pop = 1;
    }else if( rbf0.r_pos > rbf0.w_pos){
        if( rbf0.r_pos < rbf0.buff + PCMBUFSIZE ){
            /* read position is not at end of buffer */
            pop = 1;
        }else{
            if( rbf0.w_pos > &rbf0.buff[0] ){
                /* read position is at end of buffer, space available at top */
                rbf0.r_pos = &rbf0.buff[0];
                pop = 1;
            }else{
                readErrCntCH0++;
            }
        }
    }else{
        /* no data in buffer(read position == write position) */
        readErrCntCH0++;
    }

    if( pop ){
        /* PCM data --> PWM output(write data to TRDGRD, buffer of TRDGRB) */
        output_sound((unsigned short)*rbf0.r_pos,(unsigned short)*rbf0.r_pos);
        rbf0.r_pos++;
        rbf0.empty++;
        dec_info0.playno++;
    }
}

void output_sound(unsigned short da0, unsigned short da1)
{
	int i, k;
	
	DA.DADR01T = da0;
	DA.DADR0 = da0 >> 8;
	DA.DADR01T = da1;
	DA.DADR1 = da1 >> 8;

	switch((da0>>8)&0xff){
		case 0x00ff:
			for(i=0;i<nPWMtpu;i++){
				part_tpu0[i] = da0 >> 8;
			}

		break;
		default:
			k = 256 / (da0 & 0x00ff);
			for(i=0;i<nPWMtpu;i++){
				if(i%k == 0){
					part_tpu0[i] = (da0 >> 8) + 1;
				} else {
					part_tpu0[i] = da0 >> 8;
				}
			}
		break;
	}
	switch((da1>>8)&0xff){
		case 0x00ff:
			for(i=0;i<nPWMtpu;i++){
				part_tpu1[i] = da1 >> 8;
			}
		break;
		default:
			k = 256 / (da1 & 0x00ff);
			for(i=0;i<nPWMtpu;i++){
				if(i%k == 0){
					part_tpu1[i] = (da1 >> 8) + 1;
				} else {
					part_tpu1[i] = da1 >> 8;
				}
			}
		break;
	}
}

// DA0,DA1싖
void open_da(void)
{
	MSTP.CRA.BIT._DA = 0;	//@W[X^oC
	DA.DACR01.BYTE = 0xe0;	//@DA0,DA1o͂ɐݒ
}


#pragma section DTC
unsigned long dtc_table1[3] ;
unsigned long dtc_table2[3] ;
#pragma section

// TMO2(P62),TMO3(P65)싖
// 8rbgJE^APWMóAP/2
void open_tmr(void)
{
  	MSTP.CRA.BIT._DTC = 0 ;	// wake up DTC

  	dtc_table1[0] = (unsigned long)&part_tmr0[0] + 0x48000000;
  	dtc_table2[0] = (unsigned long)&part_tmr1[0] + 0x48000000;
							// Repeat mode,Byte,Source address increment
  	dtc_table1[1] = (unsigned long)&TMR2.TCORB + 0x10000000;
  	dtc_table2[1] = (unsigned long)&TMR3.TCORB + 0x10000000;
							// Destination address fix
  	dtc_table1[2] = (nPWMtmr<<24) + (nPWMtmr<<16);	//0x05050000;
  	dtc_table2[2] = (nPWMtmr<<24) + (nPWMtmr<<16);	//0x05050000;

	DTC.DTCVBR = (void *)((unsigned long)__sectop("CDTCVECT")-0x500);
	SYSCR.BIT.DTCMD = 1;	// V[gAhX[h

 	DTC.DTCERC.BIT.CMIA2 = 1;
 	DTC.DTCERC.BIT.CMIA3 = 1;	
	

	MSTP.CRA.BIT._TMR23 = 0;
	TMR2.TCSR.BYTE = 0x06;	// TCORA:cycle,TCORB:duty,PP,
	TMR2.TCCR.BYTE = 0x01;	// 1/2 clock

	TMR3.TCSR.BYTE = 0x06;	// TCORA:cycle,TCORB:duty,PP,
	TMR3.TCCR.BYTE = 0x01;	// 1/2 clock
}

// 
void open_tpu(void)
{
  	MSTP.CRA.BIT._DMAC = 0 ;	// wake up DMAC

  	DMAC0.DSAR = &part_tpu0[0] ;	// Set source address
  	DMAC1.DSAR = &part_tpu1[0] ;	// Set source address
  	DMAC0.DDAR = &TPU4.TGRB ;
  	DMAC1.DDAR = &TPU5.TGRB ;
  	DMAC0.DTCR = 0 ;				// Free running
  	DMAC1.DTCR = 0 ;				// Free running
  	DMAC0.DBSR = (nPWMtpu<<16) + nPWMtpu;	//0x000b000b ;		// Repeat size 11word
  	DMAC1.DBSR = (nPWMtpu<<16) + nPWMtpu;	//0x000b000b ;		// Repeat size 11word
  	DMAC0.DMDR.LONG = 0x000060A0 ;	// repeat,word
  	DMAC1.DMDR.LONG = 0x000060A0 ;	// repeat,word
  	DMAC0.DACR.LONG = 0x00200000 ;	// sorce++,dest,sorce repeat
  	DMAC1.DACR.LONG = 0x00200000 ;	// sorce++,dest,sorce repeat
  	DMAC0.DMRSR = 106 ;			// TPU4 TGIA req vecter set
  	DMAC1.DMRSR = 110 ;			// TPU5 TGIA req vecter set
  	DMAC0.DMDR.BIT.DTE = 1 ;		// Enable DMAC0
  	DMAC1.DMDR.BIT.DTE = 1 ;		// Enable DMAC1
	
	MSTP.CRA.BIT._TPUL = 0;	// 
	TPU4.TCR.BYTE = 0x20;	// 
	TPU5.TCR.BYTE = 0x20;	// 
	TPU4.TIOR.BYTE = 0x25;	// 
	TPU5.TIOR.BYTE = 0x25;	// 
	TPU4.TGRA = 255;	// 
	TPU4.TGRB = 127;	// 
	TPU5.TGRA = 255;	// 
	TPU5.TGRB = 127;	// 
	TPU4.TMDR.BYTE = 0x02;	// 
	TPU5.TMDR.BYTE = 0x02;	// 
	TPU4.TIER.BYTE = 0x41;	// 
	TPU5.TIER.BYTE = 0x41;	// 
}

// TvO[gpC^[o^C}̏
//@IN:g
//@OUT:Ȃ
//@TPUch1TGRAŎ
void set_sampling_tmr(int rate)
{
	MSTP.CRA.BIT._TPUU = 0;		// ÔTPŨW[Xgbv
	TPU6.TCR.BYTE		= 0x20; // TGRÃRyA}b`ŃJE^NA
	TPU6.TGRA			= timer_input_clock/rate-1;		// Ԃݒ
	TPU6.TIER.BYTE		= 0x41;	// TGRA荞݂
	INTC.IPRL.BIT._TPU6A = 5;	// VAfobK̂߂ɗDx
}

// DA0,DA1~
void close_da(void)
{
	MSTP.CRA.BIT._DA = 1;		// D/AϊW[~
	DA.DACR01.BYTE = 0x00;		// o͂֎~
}

// TMRo͒~
void close_tmr(void)
{
	MSTP.CRA.BIT._TMR23 = 0;
	TMR2.TCSR.BYTE = 0x00;	// output stop
	TMR2.TCR.BYTE = 0x49;	// counter stop

	TMR3.TCSR.BYTE = 0x00;	// output stop
	TMR3.TCR.BYTE = 0x49;	// counter stop
}

void close_tpu(void)
{
	MSTP.CRA.BIT._TPUL = 0;	//
}

void start_tmr(void)
{
	TMR2.TCR.BYTE = 0x49;	// counter start,CMIA enable,counter clear A
	TMR3.TCR.BYTE = 0x49;	// counter start,CMIA enable,counter clear A	
}

void start_tpu(void)
{
	TPU.TSTR.BYTE |= 0x30;	// 
}

void start_sampling(void)
{
	TPU.TSTRB.BIT.CST6 = 1;		// 
	start_tmr();
	start_tpu();	
}

//
// DTCxN^
//
#pragma section DTCVECT
const unsigned long DTCTBL[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,	/* (64)IRQ0 - (79)IRQ15,	*/
  0,0,0,0,0,0,	/* (80) - (85),	*/
  0,			/* (86)ADI,		*/
  0,			/* (87),		*/
  0,0,0,0,		/* (88)TGI0A - (91)TGI0D,	*/
  0,			/* (92),		*/
  0,0,			/* (93)TGI1A - (94)TGI1B,	*/
  0,0,			/* (95) - (96),	*/
  0,0,			/* (97)TGI2A - (98)TGI2B,	*/
  0,0,			/* (99) - (100),*/
  0,0,0,0,		/* (101)TGI3A - (104)TGI3D,	*/
  0,			/* (105),		*/
  0,0,			/* (106)TGI4A - (107)TGI4B,	*/
  0,0,			/* (108) - (109),	*/
  0,0,			/* (110)TGI5A - (111)TGI5B,	*/
  0,0,0,0,		/* (112) - (115),	*/
  0,0,			/* (116)CMI0A - (117)CMI0B,	*/
  0,			/* (118),		*/
  0,0,			/* (119)CMI1A - (120)CMI1B,	*/
  0,			/* (121),		*/
  (unsigned long)(&dtc_table1[0]),0,	/* (122)CMI2A - (123)CMI2B,	*/
  0,			/* (124),		*/
  (unsigned long)(&dtc_table2[0]),0,	/* (125)CMI3A - (126)CMI3B,	*/
  0,			/* (127),		*/
  0,0,0,0,		/* (128)DMTEND0 - (131)DMTEND3,	*/
  0,0,0,0,		/* (132) - (135),	*/
  0,0,0,0,		/* (136)DMEEND0 - (139)DMEEND3,	*/
  0,0,0,0,0,	/* (140) - (144),	*/
  0,0,			/* (145)RXI0 - (146)TXI0,	*/
  0,0,			/* (147) - (148),	*/
  0,0,			/* (149)RXI1 - (150)TXI1,	*/
  0,0,			/* (151) - (152),	*/
  0,0,			/* (153)RXI2 - (154)TXI2,	*/
  0,0,			/* (155) - (156),	*/
  0,0,			/* (157)RXI3 - (158)TXI3,	*/
  0,0,			/* (159) - (160),	*/
  0,0,			/* (161)RXI4 - (162)TXI4,	*/
  0,			/* (163),		*/
  0,0,0,0,		/* (164)TGI6A - (167)TGI6D,	*/
  0,			/* (168),		*/
  0,0,			/* (169)TGI7A - (170)TGI7B,	*/
  0,0,			/* (171) - (172),	*/
  0,0,			/* (173)TGI8A - (174)TGI8B,	*/
  0,0,			/* (175) - (176),	*/
  0,0,0,0,		/* (177)TGI9A - (180)TGI9D,	*/
  0,			/* (181),		*/
  0,0,			/* (182)TGI10A - (183)TGI10B,	*/
  0,0,			/* (184) - (185),	*/
  0,			/* (186)TGI10V,	*/
  0,			/* (187),		*/
  0,0,			/* (188)TGI11A - (189)TGI11B,	*/
} ;
#pragma section

#ifdef __cplusplus
void abort(void)
{

}
#endif
